
#ifndef __UOS_EXPAND_H_
#define __UOS_EXPAND_H_

#include <linux/types.h>

struct buffer_head_ext {
	unsigned int pid;       /* association to a task which write this page  */
    union {
        unsigned long sha256[4]; /* used for sha256 page, sha1[0]: the first 64bit of sha256 */
        unsigned char wb_flag;   /* used for direct_1 write back page, associated with direct_1_flag */
    };	
};

struct iomap_page_ext {	
	unsigned int pid;       /* association to a task which write this page  */
    union {
        unsigned long sha256[4]; /* used for sha256 page, sha1[0]: the first 64bit of sha256 */
        unsigned char wb_flag;   /* used for direct_1 write back page, associated with direct_1_flag */
    };
};

struct task_struct_ext {
    /* used for page cache writeback optimization */
	bool				wb_flag;
	void				*sha256_desc;
};

struct task_struct_ext* get_task_ext(struct task_struct * tsk);
#define TASK_EXT(tsk) get_task_ext(tsk)

#endif /* __UOS_EXPAND_H_ */

